.\" $Xukc: UKCCommand.man,v 1.2 90/09/22 17:32:18 rlh2 Rel $
.\"
.\" Add simple keeps to MAN macros so .TS/.TE will work
.\"
.de KS	\"	Keep start
.br
.in 0
.di KP
..
.de KE	\" 	Keep end
.br
.di
.ne \\n(dnu
.nr fI \\n(.u
.nf
.KP
.if \\n(fI .fi
.in
..
.TH "UKCCOMMAND" "LOCAL X"
.na
.nh
.SH NAME
UKCCommandWidgetClass \- An X Widget which produces a command button.
.SH SYNOPSIS
\fB
.B #include <X11/StringDefs.h>
.br
.B #include <X11/Intrinsic.h>
.br
.br
\fB#include <X11/Xukc/Command.h>
\fR
.SH CLASSES
A subclass of Core, Simple, and UKCLabel class.
.P
The widget class to use when creating a 
.I UKCCommand\^
widget is \fBukcCommandWidgetClass\fP.
.P
The class name of 
.I UKCCommand\^
is "UKCCommand".
.SH DESCRIPTION
The \fIUKCCommand\fP class provides a rectangular button which can contain a
text label and/or bitmaps.  This button can call application routines registered
with its callback list, \fBXtNcallback\fP.  When the cursor is within the
button's boundary an internal border is highlighted (both the size and colour
of this border can be adjusted - this is a difference between the
Athena command widget and \fIUKCCommand\fP),  showing that the button can be
pressed.  By pressing and releasing the first
mouse button the callback routines placed on the \fBXtNcallback\fP resource
are invoked.  This default behaviour can be modified by changing the
translation string, \fBXtNtranslations\fP, and by using the \fBUKCCommand\fP
defined actions.
.SH "NEW RESOURCES"
To specify any of these resources within a resource defaults file,
simply drop the \fIXtN\fP prefix from the resource name.
.I UKCCommand\^
defines the following new resources:
.sp 1
.KS
.TS
center allbox;
cB sss
lB lB lB lB
llll.
UKCCommand Resource Set
Name	Class	Type	Default
_
XtNcallback	XtCCallback	Pointer	NULL
XtNhighlightColor	XtCHighlightColor	Pixel	XtDefaultForeground
XtNhighlightThickness	XtCThickness	Dimension	2
.TE
.KE
.sp 1
.IP \fBXtNcallback\fP
This resource provides a callback mechanism which allows applications to
place routines on the callback list.  These are called in order by the
command widget when the command button is pressed and released (assuming the
default translations are being used).
Callback routines registered with this callback are called by the
\fIUKCCommand\fP action \fBnotify(\|)\fP (the button must be \fBset(\|)\fP
beforehand).
.IP \fBXtNhighlightColor\fP
This resource specifies the colour of the highlighting rectangle generated by
the \fBhighlight(\|)\fP action.  This defaults to the default foreground colour
of the application.
.IP \fBXtNhighlightThickness\fP
This resource specifies the pixel width of the highlighting rectangle
generated by the \fBhighlight(\|)\fP.
.SH "INHERITED RESOURCES"
The following resources are inherited from the named superclasses:
.sp 1
.KS
.TS
center allbox;
cB sss
lB lB lB lB
llll.
Core Resource Set -- CORE(3X)
Name	Class	Type	Default
_
XtNaccelerators	XtCAccelerators	XtTranslations	NULL
XtNancestorSensitive	XtCAncestorSenstitive	Boolean	TRUE
XtNbackground	XtCBackground	Pixel	XtDefaultBackground
XtNborder	XtCBorder	Pixel	XtDefaultForeground
XtNborderWidth	XtCBorderWidth	Dimension	0
XtNcolormap	XtCColormap	Pointer	NULL
XtNdepth	XtCDepth	Cardinal	0
XtNdestroyCallback	XtCCallback	Pointer	NULL
XtNheight	XtCHeight	Dimension	text height
XtNmappedWhenManaged	XtCMappedWhenManaged	Boolean	TRUE
XtNscreen	XtCScreen	XScreen *	0
XtNsensitive	XtCSensitive	Boolean	TRUE
XtNwidth	XtCWidth	Dimension	text width
XtNx	XtCPosition	Position	0
XtNy	XtCPosition	Position	0
.TE
.KE
.sp 1
.KS
.TS
center allbox;
cB sss
lB lB lB lB
llll.
Simple Resource Set -- SIMPLE(3X)
Name	Class	Type	Default
_
XtNcursor	XtCCursor	Cursor	hand2
XtNinsensitiveBorder	XtCInsensitive	Pixmap	Grey
.TE
.KE
.sp 1
.KS
.TS
center allbox;
cB sss
lB lB lB lB
llll.
Label Resource Set -- UKCLABEL(3X)
Name	Class	Type	Default
_
XtNbitmap	XtCBitmap	Bitmap	None
XtNbarColour	XtCForeground	Pixel	XtDefaultForeground
XtNeditable	XtCEditable	Boolean	True
XtNediting	XtCEditing	Boolean	False
XtNeditCallback	XtCCallback	CallbackList	NULL
XtNfont	XtCFont	XFontStruct *	XtDefaultFont
XtNforeground	XtCForeground	Pixel	XtDefaultForeground
XtNgrabKeyboard	XtCGrabKeyboard	Boolean	False
XtNinternalHeight	XtCHeight	Dimension	2
XtNinternalWidth	XtCWidth	Dimension	4
XtNjustify	XtCJustify	XtJustify	XtJustifyCenter
XtNlabel	XtCLabel	String	Name of widget
XtNoverflowRight	XtCOverflowRight	Boolean	False
XtNoverflowTop	XtCOverflowTop	Boolean	False
XtNresize	XtCResize	Boolean	False
XtNverticalJustify	XtCVerticalJustify	XtRVerticalJustify	center
XtNleftBitmap	XtCLeftBitmap	Bitmap	None
XtNrightBitmap	XtCRightBitmap	Bitmap	None
XtNpixmap	XtCPixmap	Pixmap	None
XtNleftPixmap	XtCLeftPixmap	Pixmap	None
XtNrightPixmap	XtCLeftPixmap	Pixmap	None
.TE
.KE
.sp 1
.SH "TRANSLATIONS"
The default translation set for the command button is:
.IP
~Button1<EnterWindow>:      highlight(\|)
.br
Button1<EnterWindow>:      set(\|) highlight(\|)
.br
~Button1<LeaveWindow>:      unhighlight(\|)
.br
Button1<LeaveWindow>:      reset(\|)
.br
<Btn1Down>:      set(\|)
.br
<Btn1Up>:      notify(\|) unset(\|) 
.br
<Btn2Down>:      label_edit(on)
.br
<Btn2Motion>:      position_bar(\|)
.br
:<Key>Delete:      delete_char(\|)
.br
:<Key>BackSpace:      delete_char(\|)
.br
:<Key>Return:      label_update(\|) label_edit(off)
.br
:<Key>Linefeed:      label_update(\|) label_edit(off)
.br
:<Key>Escape:      undo_edit(\|)
.br
:Ctrl<Key>h:      position_bar(-1)
.br
:Ctrl<Key>j:      position_bar(beginning)
.br
:Ctrl<Key>k:      position_bar(end)
.br
:Ctrl<Key>l:      position_bar(+1)
.br
<Key>:      insert_char(\|)
.SH "ACTIONS"
\fBhighlight:\fP  Displays the internal highlight border in the
\fBXtNhighlightColor\fP with a thickness of \fBXtNhighlightThickness\fP.
.LP
\fBunhighlight:\fP  Removes the internal highlight border by displaying it in
the \fBXtNbackground\fP colour.
.LP
\fBset:\fP  Puts the button into a \*Qset\*U state, in which \fBnotify\fP is
possible and displays the interior of the button in the \fBXtNforeground\fP
colour.  The label is displayed in the \fBXtNbackground\fP color.
.LP
\fBunset:\fP  Cancels the \*Qset\*U state and displays the interior of the
button in the \fBXtNbackground\fP colour.  The label is displayed in the
\fBXtNforeground\fP color.
.LP
\fBnotify:\fP  This is only operable during the \*Qset\*U state and causes the
callbacks on the \fBXtNcallback\fP list to be called in the order they were
added.
.LP
\fBreset:\fP  Cancels any \*Qset\*U state and resets any button highlighting.
.SH AUTHOR
Taken from the original X11R3 Athena Widget set command widget class by
DEC/MIT.
.br
Updated and revised by Richard Hesketh.
.br
rlh2@ukc.ac.uk		@nsfnet-relay.ac.uk:rlh2@ukc.ac.uk
.br
 ..!mcvax!ukc!rlh2
.br
Computing Lab., University of Kent at Canterbury, UK.
.SH SEE ALSO
\fIAthena Widget Set - C Language X Interface\fP,
.br
\fIX Toolkit Intrinsics - C Language X Interface\fP,
.br
\fIXlib - C Language Interface, Protocol Version 11\fP.





