/* $Id: button_create.c,v 1.4 91/04/15 18:57:30 rlh2 Exp $ */

#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Core.h>
#include <X11/Xukc/Toggle.h>
#include <X11/Xukc/Label.h>
#include <X11/Xukc/Layout.h>
#include <X11/Xukc/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Shell.h>
#include "perly.h"

extern void BindOutputInterface();


struct w_list {
	Widget		*w;		/* widget to create */
	String		widget_name;
	Widget		*parent;
	WidgetClass	*wc;
	Arg		*args;
	Cardinal	num_args;
	Boolean		managed;
};

struct w_connections {
	Widget *layout;
	Widget *w1;
	Widget *w2;
	Positioning pos;
};

Widget perly;
Widget  perly_box;
Widget   edit_layout;
Widget    edit_pane;
Widget     output_pane;
Widget      stdout_output_layout;
Widget	     stdout_title;
Widget      stderr_output_layout;
Widget	     stderr_title;
Widget    perly_edit_title;
Widget    blank;

struct app_resources abutton;

static Arg no_args[1];
#define NO_ARGS 0

/* WIDGET LIST START : do not remove or change this comment */

/* list of widgets in the static part of the user interface */

struct w_list perly_button_list[] = {
 { &perly_box, "perlyBox", &abutton.perly, &boxWidgetClass, no_args, NO_ARGS, 1 },
 { &abutton.perly_button, "perlyButton", &perly_box, &ukcCommandWidgetClass, no_args, NO_ARGS, 1 },
 { &abutton.transparent, "transparent", &perly_box, &widgetClass, no_args, NO_ARGS, 0 },
 { &abutton.perly_icon, "perlyIcon", &perly_box, &labelWidgetClass, no_args, NO_ARGS, 0 },
};

struct w_list edit_popup_list[] = {
 { &abutton.edit_popup, "editPopup", &abutton.perly, &transientShellWidgetClass, no_args, NO_ARGS, 1 },
 { &edit_layout, "editLayout", &abutton.edit_popup, &ukcLayoutWidgetClass, no_args, NO_ARGS, 1 },
 { &abutton.hide_edit_button, "hideEditButton", &edit_layout, &ukcCommandWidgetClass, no_args, NO_ARGS, 1 },
 { &edit_pane, "editPane", &edit_layout, &panedWidgetClass, no_args, NO_ARGS, 1 },
 { &output_pane, "outputPane", &edit_pane, &panedWidgetClass, no_args, NO_ARGS, 1 },
 { &stdout_output_layout, "stdoutOutputLayout", &output_pane, &ukcLayoutWidgetClass, no_args, NO_ARGS, 1 },
 { &abutton.stdout_text, "stdoutText", &stdout_output_layout, &asciiTextWidgetClass, no_args, NO_ARGS, 1 },
 { &abutton.stdout_clear, "stdoutClear", &stdout_output_layout, &ukcCommandWidgetClass, no_args, NO_ARGS, 1 },
 { &stdout_title, "stdoutTitle", &stdout_output_layout, &ukcLabelWidgetClass, no_args, NO_ARGS, 1 },
 { &stderr_output_layout, "stderrOutputLayout", &output_pane, &ukcLayoutWidgetClass, no_args, NO_ARGS, 1 },
 { &abutton.stderr_text, "stderrText", &stderr_output_layout, &asciiTextWidgetClass, no_args, NO_ARGS, 1 },
 { &abutton.stderr_clear, "stderrClear", &stderr_output_layout, &ukcCommandWidgetClass, no_args, NO_ARGS, 1 },
 { &stderr_title, "stderrTitle", &stderr_output_layout, &ukcLabelWidgetClass, no_args, NO_ARGS, 1 },
 { &abutton.edit_script, "editScript", &edit_pane, &asciiTextWidgetClass, no_args, NO_ARGS, 0 },
 { &perly_edit_title, "perlyEditTitle", &edit_layout, &ukcLabelWidgetClass, no_args, NO_ARGS, 1 },
 { &abutton.execute_button, "executeButton", &edit_layout, &ukcCommandWidgetClass, no_args, NO_ARGS, 1 },
 { &abutton.interrupt_button, "interruptButton", &edit_layout, &ukcCommandWidgetClass, no_args, NO_ARGS, 1 },
 { &abutton.pause_button, "pauseButton", &edit_layout, &ukcToggleWidgetClass, no_args, NO_ARGS, 1 },
 { &abutton.edit_button, "editButton", &edit_layout, &ukcToggleWidgetClass, no_args, NO_ARGS, 1 },
 { &blank, "blank", &edit_layout, &widgetClass, no_args, NO_ARGS, 1 },
 { &abutton.quit_button, "quitButton", &edit_layout, &ukcCommandWidgetClass, no_args, NO_ARGS, 0 },
};


/* widget connection list for UKCLayout widgets */
struct w_connections perly_button_connections[] = {
	{ &edit_layout, &perly_edit_title, &edit_layout, vertical_above },
	{ &edit_layout, &perly_edit_title, &edit_layout, horizontal_before },
	{ &edit_layout, &abutton.execute_button, &edit_layout, vertical_above },
	{ &edit_layout, &abutton.execute_button, &perly_edit_title, horizontal_before },
	{ &edit_layout, &abutton.interrupt_button, &edit_layout, vertical_above },
	{ &edit_layout, &abutton.interrupt_button, &abutton.execute_button, horizontal_before },
	{ &edit_layout, &abutton.pause_button, &edit_layout, vertical_above },
	{ &edit_layout, &abutton.pause_button, &abutton.interrupt_button, horizontal_before },
	{ &edit_layout, &abutton.edit_button, &edit_layout, vertical_above },
	{ &edit_layout, &abutton.edit_button, &abutton.pause_button, horizontal_before },
	{ &edit_layout, &abutton.quit_button, &edit_layout, vertical_above },
	{ &edit_layout, &abutton.quit_button, &abutton.edit_button, horizontal_before },
	{ &edit_layout, &blank, &edit_layout, vertical_above },
	{ &edit_layout, &blank, &abutton.quit_button, horizontal_before },
	{ &edit_layout, &abutton.hide_edit_button, &edit_layout, vertical_above },
	{ &edit_layout, &abutton.hide_edit_button, &blank, horizontal_before },
	{ &edit_layout, &edit_pane, &perly_edit_title, vertical_above },
	{ &edit_layout, &edit_pane, &abutton.execute_button, vertical_above },
	{ &edit_layout, &edit_pane, &abutton.edit_button, vertical_above },
	{ &edit_layout, &edit_pane, &abutton.hide_edit_button, vertical_above },
	{ &edit_layout, &edit_pane, &abutton.quit_button, vertical_above },
	{ &edit_layout, &edit_pane, &blank, vertical_above },
	{ &edit_layout, &edit_pane, &abutton.interrupt_button, vertical_above },
	{ &edit_layout, &edit_pane, &abutton.pause_button, vertical_above },
	{ &edit_layout, &edit_pane, &edit_layout, horizontal_before },
	{ &stdout_output_layout, &stdout_title, &stdout_output_layout, horizontal_before },
	{ &stdout_output_layout, &stdout_title, &stdout_output_layout, vertical_above },
	{ &stdout_output_layout, &abutton.stdout_clear, &stdout_title, horizontal_before },
	{ &stdout_output_layout, &abutton.stdout_clear, &stdout_output_layout, vertical_above },
	{ &stdout_output_layout, &abutton.stdout_text, &stdout_output_layout, horizontal_before },
	{ &stdout_output_layout, &abutton.stdout_text, &abutton.stdout_clear, vertical_above },
	{ &stdout_output_layout, &abutton.stdout_text, &stdout_title, vertical_above },
	{ &stderr_output_layout, &stderr_title, &stderr_output_layout, horizontal_before },
	{ &stderr_output_layout, &stderr_title, &stderr_output_layout, vertical_above },
	{ &stderr_output_layout, &abutton.stderr_clear, &stderr_title, horizontal_before },
	{ &stderr_output_layout, &abutton.stderr_clear, &stderr_output_layout, vertical_above },
	{ &stderr_output_layout, &abutton.stderr_text, &stderr_output_layout, horizontal_before },
	{ &stderr_output_layout, &abutton.stderr_text, &abutton.stderr_clear, vertical_above },
	{ &stderr_output_layout, &abutton.stderr_text, &stderr_title, vertical_above },
};


static Boolean
xukcIsShellClass(class)
WidgetClass class;
{
	Boolean result = FALSE;
	WidgetClass wc = class;

	while (wc != NULL && wc != shellWidgetClass)
		wc = wc->core_class.superclass;
	return (wc != NULL);
}

static void
createWidgets(widget_list, j)
struct w_list widget_list[];
Cardinal j;
{
	Cardinal i;

	for (i=0; i < j; i++)
		if (xukcIsShellClass(*(widget_list[i].wc)))
			*(widget_list[i].w) = XtCreatePopupShell(
						widget_list[i].widget_name,
						*(widget_list[i].wc),
						*(widget_list[i].parent),
						(ArgList)widget_list[i].args,
						widget_list[i].num_args);
		else {
			if (widget_list[i].managed)
				*(widget_list[i].w) = XtCreateManagedWidget(
						widget_list[i].widget_name,
						*(widget_list[i].wc),
						*(widget_list[i].parent),
						(ArgList)widget_list[i].args,
						widget_list[i].num_args);
			else
				*(widget_list[i].w) = XtCreateWidget(
						widget_list[i].widget_name,
						*(widget_list[i].wc),
						*(widget_list[i].parent),
						(ArgList)widget_list[i].args,
						widget_list[i].num_args);
		}
}

static void
createConnections(connections, j)
struct w_connections connections[];
Cardinal j;
{
	Cardinal i;

	for (i=0; i < j; i++)
		XukcLayoutAddConnection(*(connections[i].layout),
						*(connections[i].w1),
						*(connections[i].w2),
						connections[i].pos);
}


/****** Module Exported Routines ********/

void
CreateANewPerlyButton(toplevel, new_button)
Widget toplevel;
struct app_resources *new_button;
{
	Dimension width, height;

	abutton = *new_button;
	abutton.perly = XtVaAppCreateShell("perly", "Perly",
					applicationShellWidgetClass,
					XtDisplay(toplevel),
					NULL);

	/* create all the widgets in the user interface */
	createWidgets(perly_button_list, XtNumber(perly_button_list));
	*new_button = abutton;
	new_button->edit_popup = NULL; /* signal that we need a popup */
}


void
GetNewEditPopup(butt)
struct app_resources *butt;
{
	Boolean state;

	if (butt->edit_popup != NULL)
		return;

	abutton = *butt;
	createWidgets(edit_popup_list, XtNumber(edit_popup_list));
	createConnections(perly_button_connections,
				XtNumber(perly_button_connections));

	butt->edit_popup = abutton.edit_popup;
	butt->hide_edit_button = abutton.hide_edit_button;
	butt->stdout_text = abutton.stdout_text;
	butt->stdout_clear = abutton.stdout_clear;
	butt->stderr_text = abutton.stderr_text;
	butt->stderr_clear = abutton.stderr_clear;
	butt->edit_script = abutton.edit_script;
	butt->execute_button = abutton.execute_button;
	butt->edit_button = abutton.edit_button;
	butt->interrupt_button = abutton.interrupt_button;
	butt->pause_button = abutton.pause_button;
	butt->quit_button = abutton.quit_button;

	BindOutputInterface(butt);
	state = (butt->is_executing && !butt->has_finished);
	XtSetSensitive(butt->interrupt_button, state);
	XtSetSensitive(butt->pause_button, state);
	XtSetSensitive(butt->execute_button, !state);
}
