/* $Id: perly.h,v 1.4 91/03/09 13:56:11 rlh2 Exp $ */

/* 
 * Copyright 1990 Richard Hesketh / rlh2@ukc.ac.uk
 *                Computing Lab. University of Kent at Canterbury, UK
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of Richard Hesketh and The University of
 * Kent at Canterbury not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission.
 * Richard Hesketh and The University of Kent at Canterbury make no
 * representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * Richard Hesketh AND THE UNIVERSITY OF KENT AT CANTERBURY DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL Richard Hesketh OR THE
 * UNIVERSITY OF KENT AT CANTERBURY BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE
 * OF THIS SOFTWARE.
 *
 * Author:  Richard Hesketh / rlh2@ukc.ac.uk, 
 *                Computing Lab. University of Kent at Canterbury, UK
 */

struct app_resources {
	int	popup_response;
	int	icon_response;
	String	script;
	String	execution_directory;
	String	save_directory;
	Boolean	show_quit;
	Boolean pass_selection;
	Boolean split_selection;
	Boolean beep;
	Boolean popdown_on_completion;
	Boolean auto_clear;
	Boolean use_stdin;

	String filename;

	/* These attributes depend on the type of server and therefore we
	 * must save these separately bound with the server type.
	 */
	Cardinal this_server;
	Cardinal server_id;	/* "vendor name and depth of root window" */
	Cardinal num_servers;
	Cardinal geometry;
	Cardinal font;
	Cardinal foreground;
	Cardinal background;
	Cardinal highlight_colour;
	Cardinal edit_colour;
	Cardinal bitmap;
	Cardinal left_bitmap;
	Cardinal right_bitmap;

	/* These widget describe the interface to each button instance */
	Widget perly;
	Widget perly_button;
	Widget perly_icon;
	Widget transparent;

	Widget edit_popup;
	Widget edit_script;
	Widget hide_edit_button;
	Widget execute_button;
	Widget edit_button;
	Widget pause_button;
	Widget stderr_clear;
	Widget stderr_text;
	Widget stdout_clear;
	Widget stdout_text;
	Widget interrupt_button;
	Widget quit_button;

	Boolean sent_interrupt;
	Boolean has_finished;
	int pipefds[2];
	Boolean both_pipes_closed;
	XtInputId output_pipe_id;
	XtInputId error_pipe_id;
	Boolean edit_is_up;
	Boolean is_executing;
	Boolean just_mapped;
	String	scriptfile;
	int	pid;
};

#define XukcRPopupResponse "PopupResponse"

#define XukcEpopupOnOutput "popuponoutput"
#define XukcEpopupOnCompletion "popuponcompletion"
#define XukcEnoPopup "nopopup"

#define POPUP_ON_OUTPUT 1
#define POPUP_ON_COMPLETION 2
#define NO_POPUP 3

#define XukcRIconResponse "IconResponse"

#define XukcEiconOnWhenOutput "icononwhenoutput"
#define XukcEiconAlwaysOn "iconalwayson"
#define XukcEiconAlwaysOff "iconalwaysoff"

#define ICON_ON_WHEN_OUTPUT 1
#define ICON_ALWAYS_ON 2
#define ICON_ALWAYS_OFF 3

#define NUM_ICON_LINES 8

#define PROG_NAME "perly"

#ifndef PROGRAM_NAME
#define PROGRAM_NAME "/usr/local/wbin/X11/perly"
#endif /* PROGRAM_NAME */

#define OUTPUT_POPUP_CREATED(butt) (butt->edit_popup != NULL)

#define SAVE_DIRECTORY "PERLY_BUTTONS"
