.TH PERLY 1
.SH NAME
perly \- Execute Perl or other scripts via a graphical button
.br
king \- Perly button manager
.SH SYNOPSIS
.B perly
[
.B \-popup
[
.B popupOnOutput
|
.B popupOnCompletion
|
.B noPopup
] [
.B \-execdir
.I directory
] [
.B \-savedir
.I directory
] [
.B \-noargs
] [
.B \-quit
] [
.B \-beep
] [
.B \-stdin
] [
.B standard X Toolkit options
]
.I button_file
.sp
.B king
.SH DESCRIPTION
.nh
.I perly
is a graphical means of running Perl scripts or shell scripts under the X
Window System.  Each time
.I perly
is invoked it displays a graphical button.  If a file is given to
.I perly
it is read as the description of the button which contains a script.  When
.I perly
is exited it saves its current state in a file.  This file is an executable
script which runs
.I perly
again with the previous internal state.

Each
.I perly
button consists of three windows.  Only one window is shown by default.
This is the main button which is used to execute the internal script and to
pop up the other two windows.  These other windows are the OUTPUT and script
window and the TAILORING window.  The OUTPUT window contains any output
created by the executing script, it also contains the script which can be
edited.  The TAILORING window contains options for changing the appearance of
the \fIperly\fP button and some of its operational aspects.

.I king
can be used to automatically run these description files and can be used in
an X start up file to cause the buttons to be created at each X login
session.  Each button automatically saves itself when the X session finishes.

The button window responds to the following
X events:
.IP 1st\ Mouse\ Button\ Pressed\ and\ Released
Execute the buttons' script.  Whilst the script is executing the button name
is \fIgreyed out\fP and only returns to its normal colour when the script has
finished.  This will not cause the script to be executed if the output
window is popped up, here the \fIExecute\fP button must be pressed.
To interrupt a scripts' execution the user must first popup the output window
and then press the \fIInterrupt\fP button.
.IP 2nd\ Mouse\ Button\ Pressed
Start editing the button name.  If this mouse button is held down and the
mouse is moved the vertical insertion bar is moved along the buttons' name.
Typing characters inserts them in the name at the bars' current position.
The \fIdelete\fP key deletes the character before the bar.  Pressing the
\fIreturn\fP finishes the editing and causes the button to resize itself to
contain all of the edited name.  The name cannot be edited whilst the script
is being executed.
.IP 1st\ Mouse\ Button\ Pressed\ with\ SHIFT\ key\ held\ down
Display the OUTPUT window (pressing this again pops down the window).
.IP 2nd\ Mouse\ Button\ Pressed\ with\ SHIFT\ key\ held\ down
Display the TAILORING window (pressing this again pops down the window).
.IP 3rd\ Mouse\ Button\ Pressed\ with\ SHIFT\ key\ held\ down
Create a new button.  Whilst holding these down a wire frame can be dragged
to a new position on the screen and dropped when the mouse button is released.  A new \fIperly\fP button process is started in this position.  When this new
button is quit its description will be saved in a file whose name is created
from the name of the button.  It will be saved in the directory pointed to by
the PERLY_BUTTON environment variable or the \-savedir command line argument
given to the original button.
.LP
The button window also responds to the key combinations: \fB<Meta>Q\fP and
\fB<Control>C\fP which quits the \fBperly\fP button and saves its current
state.  The \fB<Meta>Escape\fP key combination causes the button to quit
without saving state.
.SH OPTIONS
.IP \fB\-popup\fP popupOnOutput popupOnCompletion noPopup
specifies when the output window should be popped up when the script is being
executed.  Three responses are available \fIpopupOnOutput\fP,
\fIpopupOnCompletion\fP or \fInoPopup\fP.
.IP \fB\-execdir\fP\ \fIdirectory\fP
which directory to execute the script from.  This defaults to the users home
directory as specified in their password file entry.
.IP \fB\-savedir\fP\ \fIdirectory\fP
which directory to save the button description file in.  This flag overrides
the PERLY_BUTTON environment variable.
.IP \fB\-noargs\fP
do not pass the current selection in the PRIMARY selection buffer to the
executing script as arguments.
.IP \fB\-quit\fP
show the quit button in the output popup window.
.IP \fB\-beep\fP
beep on completion of an executed script.
.IP \fB\-stdin\fP
allow input sent to the standard input to go to the script.  Currently reserved
for future use by combination buttons.
.SH OUTPUT POPUP WINDOW
This window contains two main areas: the output window and the error window.
This shows the output from the script once executed.
To execute the script whilst
the output window is popped up the \fIExecute\fP button should be  pressed.
Whilst the script is executing the \fIInterrupt\fP button can be pressed to
interrupt its execution.  If the script fails to terminate the
\fIInterrupt\fP button can be pressed again and the script is sent a kill
signal.  Output in these windows can be \fIcut\fP using the first mouse button
and pasted into other windows via the standard X selection mechanism.

By default the script that is to be executed is not shown in the output
window.  To see (and edit) the script the user must press the \fIEdit\fP
button which is to the right of the \fIInterrupt\fP button.  This moves the
two output areas up to allow the script to be displayed.  The script can be
edited directly using the mouse and the keyboard.  The size of each area can
be adjusted by clicking on and dragging the "grip" square to the top right of
the error and script areas.  The syntax of the script is described in the SCRIPT
SYNTAX section below.  Pressing the \fIEdit\fP button again hides the
script.
.SH TAILORING POPUP WINDOW
The tailoring window allows different attributes of the \fBperly\fP button to
be changed by the user.  Apart from the name being directly edited in the
button this window allows the colours, font and bitmaps to be changed.
The window contains toggling buttons, one-of-many (radio) buttons and editable
text areas.  The first mouse button is used to change the toggle and radio
buttons.  The second mouse button when pressed inside a text area reveals the
insertion bar which is also used to edit the buttons' name.

The options at the top of the tailoring window correspond to the command line
arguments detailed in OPTIONS.

Choosing the font can be done either by editing the font name or by selecting
the font with a program that uses the PRIMARY_FONT selection property.
One such program is
\fBxfontsel\fP which allows any font to be chosen using the X Font naming
scheme.  When you have selected the required font and have placed its name
in the PRIMARY_FONT selection property (e.g. by pressing the "select" button
in \fBxfontsel\fP); pressing the left mouse button in the font name causes
\fBperly\fP to load the font whose name has been selected.  Both the button
name and the font name are redisplayed using this new font.
.SH SCRIPT SYNTAX
By default the buttons' script is passed to the standard UNIX Bourne shell,
\fBsh\fP  when it is executed.
If the first line of
the script contains the standard UNIX
\fB#!\fP sequence, such as \fB#!/usr/local/bin/perl\fP
the script is executed by program
whose absolute pathname follows this sequence.  In this example the script is
executed as a Perl shell script.
.SH DIAGNOSTICS
Errors from the executing script are shown in the
.I Standard Error Output
window.  These can be cleared using the
.I Clear
button associated with it.

Internal warnings (normally from incorrect tailoring arguments) are shown in
a separate popped up warning window.  These may be cleared or hidden using
the associated buttons in this window.
.SH ENVIRONMENT VARIABLES
PERLY_BUTTONS \- directory containing perly buttons started up by
.B king
.SH FILES
PERLY_BUTTONS/* \- user buttons description files
/usr/local/lib/perly/* \- example buttons
.SH SEE ALSO
perl(l)\ \ sh(1)
.SH AUTHOR
Richard Hesketh : rlh2@ukc.ac.uk
.SH HISTORY
14th February 1990 : First experimental release of buttons, with a minimal
button manager.
.SH BUGS
Using CSH for the script does not produce any output.
.br
The button manager (\fIking\fP) is only a shell script which runs the perly
buttons created under previous login sessions and will be replaced as soon as
possible.
