/*  Public header file for Lexical Analyser/Parser for Getfields  */


#define MALFORMED_LINE		0
#define MISS_AFTER_ANDOR	1
#define MISS_AFTER_EXCOR	2
#define MISS_AFTER_HASH		3
#define MIXED_OPS		4
#define NOT_START_EQUALS	5
#define NOT_START_ANDOR		6
#define NOT_START_EXCOR		6
#define ILLEG_CHAR_IN_VAL	7
#define MISS_BEF_ANDOR		8
#define MISS_BEF_EXCOR		9
#define NOT_START_HASH		10
#define VAR_NOT_DEFAULT		11
#define TOO_MANY_DEFS		12
#define HASH_IN_STRING		13
#define QU_NOT_DEFAULT		14
#define ILLEG_CHAR_IN_VAR	15
#define COMM_NOT_FIRST		16
#define MISS_QUESTION		17
#define INVERT_TILDE_EQUALS	18
#define MISS_VAR_NAME		19
#define MISS_VN_INV_TE		20
#define MISS_VN_AND_EQ		21
#define MISS_QU_AND_TI		22
#define MISS_BEF_PERCENT	23
#define MISS_AFTER_PERCENT	24


#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif !TRUE

struct list_of_values {
    char *val;
    char *out_val;  /*  What will be output instead of the name */
    char  chosen;   /*  Actually a Boolean, but cannot #inc. X11/Intrinsics   */
		    /*  here since 'input' is defined in them and in Lex.     */
    struct  list_of_values  *next;
};

typedef struct list_of_values LIST_VALS;


struct widget_instance {
    char *widg_type;
    char *question;
    char *var_name;
    LIST_VALS  *val_list;
    struct  widget_instance  *next;
};

typedef struct widget_instance  WIDG_INSTANCE;


struct file_widgets {
     WIDG_INSTANCE  *widglist;
     FILE    *outp;
};

typedef struct file_widgets  FIL_WIDS;
