
  			    /*********************
			    *  LEX DECLARATIONS  *
			    *********************/

%{

#include "y.tab.h"
#include "inp.h"

#define STRLEN(s) (strlen(s) + 1)

enum position {FIRST, SECOND, OTHER};

WIDG_INSTANCE  *wid_ins;
int  error_count = 0;
int  num_of_hashes = 0;
int  where_tilde = 0;
int  where_equals = 0;
int  space_created = 'n';
char *buffer = NULL, *new_strng = NULL;
enum position  pos = FIRST;

	/*******************************
	*  Forward declare functions.  *
	*******************************/

WIDG_INSTANCE  *AddQues();
WIDG_INSTANCE  *AddVarName();
WIDG_INSTANCE  *AddValue();
LIST_VALS      *AdV();
char *AddToBuf();
char *emalloc();
char *stringsave();
char *strcpy();
extern char *malloc();
extern char *realloc();

%}

				/**************
				*  LEX RULES  *
				**************/

%%

[A-Za-z][A-Za-z0-9_]*			{ if (pos == FIRST)
			  	      	  {
			      	              buffer = stringsave(yytext);
			                      pos = SECOND;
			      	              if (error_count == 0)
			                          wid_ins = AddQues(wid_ins, yytext);
			                  }
			                  else 
			                  {
					      if (pos == SECOND)
					      {
                                                  new_strng = stringsave(yytext);
			                          buffer = AddToBuf(buffer, new_strng);
					          pos = OTHER;
			      	                  if ((error_count == 0) && (space_created == 'y'))
			          	              wid_ins = AddVarName(wid_ins, yytext);
			                      }
			                      else
			                      {
                                                  new_strng = stringsave(yytext);
			                          buffer = AddToBuf(buffer, new_strng);
			      	                  if ((error_count == 0) && (space_created == 'y'))
			                              wid_ins = AddValue(wid_ins, yytext, FALSE);
			                      }
					  }
			                  return (VARNAME);
				        }

[#]+[ \t]*[^%|@#~=\n]*[^ \t%|@#~=\n]	{ if (pos == FIRST)
			          	  {
				      	      buffer = stringsave(yytext);
				      	      pos = SECOND;
				              error_found(strlen(buffer), QU_NOT_DEFAULT);
			 	          }
			                  else 
			                  {
					      if (pos == SECOND)
					      {
                                                  new_strng = stringsave(yytext);
			                          buffer = AddToBuf(buffer, new_strng);
					          pos = OTHER;
						  if (buffer[strlen(buffer)-strlen(new_strng)-1] == '~')
				                      error_found(strlen(buffer), VAR_NOT_DEFAULT);
			                      }
				              else
				              {
				                  new_strng = stringsave(yytext);
				                  buffer = AddToBuf(buffer, new_strng);
			      	                  if ((error_count == 0) && (space_created == 'y'))
				                  {
 				                      int   i = 0;
					              char  *temp;

					              while ((yytext[i] == ' ') || (yytext[i] == '\t') || (yytext[i] == '#'))
					                  i++;
					              temp = (char *)emalloc(STRLEN(yytext) - i);
					              strcpy(temp, yytext + i);
					              wid_ins = AddValue(wid_ins, temp, TRUE);
					              free(temp);
				                  }
				                  num_of_hashes++;
					      }
				          }
				          return (HASHSTRING);
					}

[^ \t%|@#~=\n][^%|@#~=\n]*[^ \t%|@#~=\n]	{ if (pos == FIRST)
			  	      	  {
			      	              buffer = stringsave(yytext);
			                      pos = SECOND;
			      	              if (error_count == 0)
			          	          wid_ins = AddQues(wid_ins, yytext);
			                  }
			  	      	  else
					  {
 					      if (pos == SECOND)
					      {
                                                  new_strng = stringsave(yytext);
			                          buffer = AddToBuf(buffer, new_strng);
			                          pos = OTHER;
						  if (buffer[strlen(buffer)-strlen(new_strng)-1] == '~')
				                      error_found(strlen(buffer), ILLEG_CHAR_IN_VAR );
			                      }
			                      else
			                      {
                                                  new_strng = stringsave(yytext);
			                          buffer = AddToBuf(buffer, new_strng);
			      	                  if ((error_count == 0) && (space_created == 'y'))
			                              wid_ins = AddValue(wid_ins, yytext, FALSE);
			                      }
					  }
			                  return (STRING);
				        }

[^ \t%|@#~=\n]	{ if (pos == FIRST)
 		  {
  		      buffer = stringsave(yytext);
                      pos = SECOND;
	              if (error_count == 0)
                          wid_ins = AddQues(wid_ins, yytext);
                  }
                  else
                  {
 		      if (pos == SECOND)
		      {
                          new_strng = stringsave(yytext);
                          buffer = AddToBuf(buffer, new_strng);
		          pos = OTHER;
			  if (buffer[strlen(buffer)-strlen(new_strng)-1] == '~')
	                      error_found(strlen(buffer), ILLEG_CHAR_IN_VAR);
                      }
                      else
                      {
                          new_strng = stringsave(yytext);
                          buffer = AddToBuf(buffer, new_strng);
	                  if ((error_count == 0) && (space_created == 'y'))
                              wid_ins = AddValue(wid_ins, yytext, FALSE);
                      }
		  }
                  return (STRING); }

[^ \t%|@#~=\n][^%|@~=\n]*[^ \t%|@~=\n]	{ if (pos == FIRST)
			  	      	  {
			      	              buffer = stringsave(yytext);
			                      pos = SECOND;
					      error_found(strlen(buffer), HASH_IN_STRING);
			                  }
			  	      	  else
					  {
 					      if (pos == SECOND)
					      {
                                                  new_strng = stringsave(yytext);
			                          buffer = AddToBuf(buffer, new_strng);
			                          pos = OTHER;
				                  error_found(strlen(buffer), HASH_IN_STRING);
			                      }
			                      else
			                      {
                                                  new_strng = stringsave(yytext);
			                          buffer = AddToBuf(buffer, new_strng);
				                  error_found(strlen(buffer), HASH_IN_STRING);
			                      }
					  }
			                  return (BADSTRING);
				        }

~		{ tokenise();
		  where_tilde = (strlen(buffer))+1;
		   return (TILDE); }

=		{ tokenise();
		  where_equals = (strlen(buffer))+1;
		   return (EQUALS); }

"|"		{ tokenise();
		  return (AND_OR); }

@		{ tokenise();
		  return (EXC_OR); }

"%"		{ tokenise();
		  return (PERCENT); }

#[ \t#]*	{ tokenise();
		  return (HASH); }

^[ \t]*\n	{ yylineno--; }

\n  		{ pos = FIRST;
  		  return (NEWLINE); }

[ \t]+		{ ; }

%%

				/****************
				*  PROGRAMS...  *
				****************/

/*---------------------------------------------------------------------*/

	/************************************************************
	*  FUNCTION ADDQUES:                                        *
	*  Fill in question in structure which holds the widget     *
	*  details.  Takes a pointer to the list of structures      *
	*  which hold the widget info. (WIDG_INSTANCE *), and the   *
	*  question for the widget to be created (pointer to char). *
	*  Called from within the Lex rules.  Calls itself recurs-  *
	*  ively to work through the list of structures.            *
	************************************************************/

WIDG_INSTANCE *
AddQues(head, ques_data)
WIDG_INSTANCE  *head;
char *ques_data;
{
    if (head == (WIDG_INSTANCE *)NULL)
    {
        head = (WIDG_INSTANCE *) emalloc(sizeof(WIDG_INSTANCE));
	space_created = 'y';
        head->question = (char *)emalloc(STRLEN(ques_data));
        strcpy(head->question, ques_data);
        head->next = NULL;
	head->val_list = NULL;
	head->widg_type = NULL;
	head->var_name = NULL;
    }
    else
        head->next = AddQues(head->next, ques_data);

    return (head);
}


/*---------------------------------------------------------------------*/

	/************************************************************
	*  FUNCTION ADDVARNAME:                                     *
	*  Fill in widget's var in structure which holds the widget *
	*  details.  Takes a pointer to the list of structures      *
	*  which hold the widget info. (WIDG_INSTANCE *), and the   *
	*  variable name to be added to the list (pointer to char). *
	*  Called from within the Lex rules.  Calls itself recurs-  *
	*  ively to work through the list of structures.            *
	************************************************************/

WIDG_INSTANCE *
AddVarName(head, var_data)
WIDG_INSTANCE  *head;
char *var_data;
{
    if (head->next == (WIDG_INSTANCE *)NULL)
    {
        head->var_name= (char *)emalloc(STRLEN(var_data));
        strcpy(head->var_name, var_data);
    }
    else
        head->next = AddVarName(head->next, var_data);

    return (head);
}


/*---------------------------------------------------------------------*/

	/************************************************************
	*  FUNCTION ADDVALUE:                                       *
	*  Find point in list to add a new value for a widget.      *
	*  Takes a pointer to the list of structures which hold     *
	*  the widget info. (WIDG_INSTANCE *), and the next value   *
	*  to be added to a particular widget's list of values.     *
	*  Called from within the Lex rules.  Calls itself recurs-  *
	*  ively to work through the list, and calls "AdV" to       *
	*  actually add the new value to the list.                  *
	************************************************************/

WIDG_INSTANCE *
AddValue(head, value_data, cho)
WIDG_INSTANCE  *head;
char  *value_data;
char  cho;
{
    static LIST_VALS  *start;

    if (head->next == (WIDG_INSTANCE *)NULL)
        head->val_list = AdV(head->val_list, value_data, cho);
    else
        head->next = AddValue(head->next, value_data, cho);

    return (head);
}

/*---------------------------------------------------------------------*/

	/************************************************************
	*  FUNCTION ADV:                                            *
	*  Add a new value to a widget's list of values.  Takes     *
	*  a pointer to the value list of a particular widget       *
	*  (LIST_VALS *), and the name of that value (pointer to    *
	*  char).  Called by "AddValue".                            *
	************************************************************/

LIST_VALS *
AdV(base, val_data, chos)
LIST_VALS  *base;
char  *val_data;
char  chos;
{
    if (base == (LIST_VALS *)NULL)
    {
        base = (LIST_VALS *) emalloc(sizeof(LIST_VALS));
        base->val = (char *)emalloc(STRLEN(val_data));
        strcpy(base->val, val_data);
  	base->chosen = chos;
	base->next = NULL;
     }
    else
        base->next = AdV(base->next, val_data, chos);

    return (base);
}

/*---------------------------------------------------------------------*/

	/*******************************************************
	*  FUNCTION TOKENISE:                                  *
	*  Adds non-string tokens to the current line buffer.  *
	*******************************************************/

tokenise()
{
  if (pos == FIRST)
  {
      buffer = stringsave(yytext);
      pos = OTHER;
  }
  else
  {
      new_strng = stringsave(yytext);
      buffer = AddToBuf(buffer, new_strng);
  }
}

/*---------------------------------------------------------------------*/

	/******************************************************
	*  FUNCTION ADDTOBUF:                                 *
	*  Takes the current line buffer and the next token.  *
	*  Adds token to current line buffer.  Called from    *
	*  within the Lex rules.  Returns the new buffer.     *
	******************************************************/

char *
AddToBuf(bufr, newstr)
char *bufr, *newstr;
{
#ifdef DEBUG
fprintf(stderr, "AddToBuf(%s, %s)\n", bufr, newstr);
    if (bufr == NULL) {
	fprintf(stderr, "ouch\n"); abort();
    }
#endif
    bufr = realloc(bufr, strlen(bufr) + STRLEN(newstr));
    strcat(bufr, newstr);

    return(bufr);
}

/*---------------------------------------------------------------------*/

	/********************************************************
	*  FUNCTION EMALLOC:                                    *
	*  Takes the size of a string; prints an error if size  *
	*  is NULL.  Called by "stringsave".                    *
	********************************************************/

char *
emalloc(size)
int size;
{
    char *tmp;

    if ((tmp = malloc((unsigned)size)) == NULL)
    {
	exit (1);
    }

    return (tmp);
}

/*---------------------------------------------------------------------*/

	/***********************************************************
	*  FUNCTION STRINGSAVE:                                    *
	*  Takes a pointer to char.  Allocates enough memory for   *
	*  a new string and returns that string.  Calls "emalloc"  *
	*  to check that the new string is not NULL.  Called from  *
	*  within the Lex rules.                                   *
	***********************************************************/

char *
stringsave(new)
char *new;
{
    if (new == NULL)
    {
	fprintf(stderr, "getf: cannot stringsave() a NULL string\n");
	exit (-1);
    }

    return (strcpy(emalloc(STRLEN(new)), new));
}
