.TH XMENU2 l "19 Febuary 1990"
.SH NAME
xmenu \- provide simple popup menus to shell scripts...
.SH SYNOPSIS
\fBxmenu\fR Menu_Items [ SubMenu_Defs ][ Options ]

.br
Menu_Items:
    [\|\fI menu_entry\fR[\fI=output_value\fR] | \fB-line \fR\|] ...
.br
SubMenu_Defs:
    [\|\fB -menu\fI submenu_label \fRMenu_Items ...\fB -unem \fR\|]
.br
Options:
    [\|\fB -heading\fI menu_title \fR\|]
    [\|\fB -punt\fI default_value \fR\|]
    [\|\fB -geo\fI geometry \fR\|]
    [\|\fB -nest\fI number \fR\|]
    [\|\fB -xtra\fI number \fR\|]
    [\|\fB -bell\fR | \fB-quiet \fR\|]
.SH DESCRIPTION
\fIxmenu\fP provides a quick and easy way of producing an OSF/Motif popup menu
for use by shell scripts.  Both simple and cascading menus are supported in
this version of \fIxmenu\fP.  By default the menu is popped up to the right
and below of the current pointer position but this can be overridden using the
\fI-geo\fP option.  Following the example of \fIxmessage\fP the exit status is
set to a number greater than or equal to 101, indicating which menu item was
pressed.
.SH ARGUMENTS
.TP 8
.I menu_entry[=output_value]\fP
Specifies a menu entry with a widget name of \fBmenuButton\fP.  If the
argument contains an equals sign then the string to the left of the equals is
used as the displayed menu item and the string to the right is used as the
text output when the item is pressed.  If no equals sign is present in the
argument then the argument itself is output.  This specification is used for
all menu entries, including those in a submenu...
.TP 8
.B \-line\fP
Specifies a separator line menu item with a widget name of \fBmenuLine\fP and
can be used in both the primary menu and submenu definitions...
.TP 8
.B \-menu \fIsubmenu_label\fP
Specifies the beginning of a submenu definition.  The \fIsubmenu_label\fP is
the label used for the cascade button in the primary menu.  The cascade
button's widget name is \fBmenuSub\fP...
.TP 8
.B \-unem\fP
Specifies the end of a submenu definition...
.TP 8
.B \-heading \fImenu_title\fP
Specifies the "title" of the popup menu.  This widget's name is
\fBmenuLabel\fP...
.TP 8
.B \-punt \fIdefault_value\fP
Specifies the default return value to be used when no items are selected from
the menu.  If not specified, the default return value is the string ""...
.TP 8
.B \-geo \fIgeometry\fP
Specifies the "posting" location, X and Y only, for the popup menu...
.TP 8
.B \-nest \fInumber\fP
Specifies the maximum depth of submenu nesting supported by the popup menu...
 [ default value: 10 ]
 [ minimum value: 10 ]
.TP 8
.B \-xtra \fInumber\fP
Specifies the maximum number of menu entries allowed in a menu/submenu.  When this number is exceeded,
\fIxmenu\fP will automatically create a new cascade
button and will continue putting the "xtra" menu/submenu items into it's associated submenu.  The cascade
button's widget name is \fBmenuXtra\fP... 
 [ default value: 32 ]
 [ minimum value: 10 ]
.TP 8
.B \-bell\fP
Enables the \fIXBell()\fP calls embedded in \fIxmenu\fP...
.TP 8
.B \-quiet\fP
Disables the \fIXBell()\fP calls embedded in \fIxmenu\fP... 
 [ default ]
.SH RESOURCES
The widget class of the \fIxmenu\fP application is \fBXmMenu\fP and it's
instance name is \fBxmMenu\fP.  The following resouces can only be accessed
thru the instance name as shown;
.TP 8
.B xmMenu.bell\fP [ True/False ]
Accepts the string "True" to enable the \fIXBell()\fP calls embedded within
\fIxmenu\fP (see \fI-bell\fP above).  All other strings will fail to match
(see \fI-quiet\fP above)...
.TP 8
.B xmMenu.geo\fP [ geometry ]
Accepts a geometry string but only uses the location values from this string.
See the \fI-geo\fP option above for a description of it's usage...
.TP 8
.B xmMenu.heading\fP [ string ]
See the \fI-heading\fP option above for a description of it's usage...
.TP 8
.B xmMenu.punt\fP [ string ]
See the \fI-punt\fP option above for a description of it's usage...
.TP 8
.B xmMenu.nest\fP [ number ]
See the \fI-nest\fP option above for a description of it's usage...
.TP 8
.B xmMenu.xtra\fP [ number ]
See the \fI-xtra\fP option above for a description of it's usage...
.SH Widgets
The following is the list of "internal" widget names, with their associated
widget types, supported by \fIxmenu\fP;
.TP 12
.B menuButton\fP 
[ Push Button Gadget ]
.TP 12
.B menuLabel\fP 
[ Label Gadget ]
.TP 12
.B menuLine\fP 
[ Separator Gadget ]
.TP 12
.B menuSub\fP 
[ Cascade Button Gadget ]
.TP 12
.B menuXtra\fP 
[ Cascade Button Gadget ]
.TP 12
.B Menu\fP 
[ RowColumn Widget ]
.TP 12
.B SubMenu\fP 
[ RowColumn Widget ]
.SH DEFAULTS
The following resource strings are embedded in \fIxmenu\fP as fallback
resource values.
.DS
  *marginHeight:          1
  *marginWidth:           1
  *menuButton.fontList:  -*-helvetica-bold-r-normal--12-120-75-75*iso*
  *menuLabel.fontList:   -*-helvetica-medium-r-normal--12-120-75-75*iso*
  *menuSub.fontList:     -*-helvetica-medium-r-normal--12-120-75-75*iso*
  *menuXtra.fontList:    -*-helvetica-medium-r-normal--12-120-75-75*iso*"
  *menuXtra.labelString:  Xtra...
.DE
.SH EXAMPLES
.DS
xmenu -heading "Choose Files by Suffix" \\
       Compressed="*.Z" "C sources"="*.c" "Headers"="*.h" \\
      -line -line "        Cancel"

xmenu Hello="Hello World" -line " " " " -line Goodbye="Goodbye World"

xmenu -heading XShell xman xmh xterm \\
      -menu games spider xmandel xlife -unem \\
      -menu tools xcmap cpicker pixedit -unem

.DE
.SH EXIT STATUS
The exit status is set to a number greater than or equal to 101.  This number
corresponds to the position of the pressed button in the menu, 101 for the
first button, 102 for the second and so on.
.SH AUTHOR
Richard Hess, Consilium Inc., Febuary 1991 [ OSF/Motif 1.1 ]
.br
cimshop!rhess@uunet.UU.NET
.br

[ OSF/Motif is a trademark of Open Software Foundation, Inc.
.SH ORIGINAL
Richard Hesketh, University of Kent at Canterbury, June 1990
.br
@nsfnet-relay.ac.uk:rlh2@ukc.ac.uk
.SH COPYRIGHT
.DT
Copyright 1991 Richard Hess and Consilium Inc.
.br
Copyright 1990 Richard Hesketh / rlh2@ukc.ac.uk
  Computing Lab. University of Kent at Canterbury, UK
.sp 1
\fBNote:\fP  see \fIxmenu2.h\fP for the terms of the copyright...
